using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Net;
using System.Net.Sockets;
using System.Threading;
using System.IO;

namespace PowerAllocationRec
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private Thread thrDownload;
        private Stream strLocal;
        private NetworkStream strRemote;
        private TcpListener tlsServer;
        private delegate void UpdateStatusCallback(string StatusMessage);
        private delegate void UpdateProgressCallback(Int64 BytesRead, Int64 TotalBytes);
        private static int PercentProgress;

        
        GroupBox GB = new GroupBox();


        private void Form1_Load(object sender, EventArgs e)
        {
            thrDownload = new Thread(StartReceiving);
            thrDownload.Start();
        }

        private void StartReceiving()
        {
            try
            {
                string hstServer = Dns.GetHostName();

                IPAddress ipaLocal = Dns.GetHostEntry(hstServer).AddressList[0];

                if (tlsServer == null)
                {
                    tlsServer = new TcpListener(ipaLocal, Convert.ToInt32(txtPort.Text));
                }
                tlsServer.Start();

                this.Invoke(new UpdateStatusCallback(this.UpdateStatus), new object[] { "Server : The server has started.\n\n" });

                TcpClient tclServer = tlsServer.AcceptTcpClient();

                string strFileName = "C:\\";

                strRemote = tclServer.GetStream();

                int bytesSize = 0;

                byte[] downBuffer = new byte[2048];

                bytesSize = strRemote.Read(downBuffer, 0, 2048);

                string FileName = System.Text.Encoding.ASCII.GetString(downBuffer, 0, bytesSize);

                strLocal = new FileStream(strFileName + FileName, FileMode.Create, FileAccess.Write, FileShare.ReadWrite);

                downBuffer = new byte[2048];

                bytesSize = strRemote.Read(downBuffer, 0, 2048);

                long FileSize = Convert.ToInt64(System.Text.Encoding.ASCII.GetString(downBuffer, 0, bytesSize));

                this.Invoke(new UpdateStatusCallback(this.UpdateStatus), new object[] { "Server : Receiving file " + FileName + " (" + FileSize + " bytes)\r\n" });

                downBuffer = new byte[2048];

                while ((bytesSize = strRemote.Read(downBuffer, 0, downBuffer.Length)) > 0)
                {
                    strLocal.Write(downBuffer, 0, bytesSize);

                    this.Invoke(new UpdateProgressCallback(this.UpdateProgress), new object[] { strLocal.Length, FileSize });
                }
                
            }
            catch (Exception)
            {
                //MessageBox.Show(ex.Message);
            }
            finally
            {
                //this.Invoke(new UpdateStatusCallback(this.UpdateStatus), new object[] { "Server : The file was received. Closing streams.\r\n" });
                this.Invoke(new UpdateStatusCallback(this.UpdateStatus), new object[] { "" });
                try
                {
                    strLocal.Close();
                    strRemote.Close();
                }
                catch (Exception)
                {
                  //  MessageBox.Show(ex.Message);
                }
                this.Invoke(new UpdateStatusCallback(this.UpdateStatus), new object[] { "" });
                //StartReceiving();
            }
        }
        

        private void UpdateStatus(string StatusMessage)
        {
            txtMsg.Text += StatusMessage;
        }
        private void UpdateProgress(Int64 BytesRead, Int64 TotalBytes)
        {
            if (TotalBytes > 0)
            {
                PercentProgress = Convert.ToInt32((BytesRead * 100) / TotalBytes);
                progress.Value = PercentProgress;
            }
        }

     

       

        
        
       
    }
}